package design_example_map;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

class BlobManagerTest {

	@Test
	@DisplayName("addBlob")
	void testAddBlob() {
		BlobManager bm = new BlobManager();
		Blob[] blobs = { new Blob("1234"), new Blob("2345"),
				new Blob("3456") };
		for(Blob b : blobs) {
			bm.addBlob(b);
		}
		assertEquals(3,bm.getNumBlobs());
	}

	@Test
	@DisplayName("getBlob(id)-valid id")
	void testGetBlob_Valid() {
		BlobManager bm = buildBlobManager3();
		String expectedId = "2345";
		Blob b = bm.getBlob(expectedId);
		assertEquals(expectedId, b.getId());
	}

	@Test
	@DisplayName("getBlob(id)-invalid id")
	void testGetBlob_Invalid() {
		BlobManager bm = buildBlobManager3();
		String invalidId = "9999";
		Blob b = bm.getBlob(invalidId);
		assertEquals(null, b);
	}

	@Test
	@DisplayName("getBlob(id)-invalid id")
	void testClear() {
		BlobManager bm = buildBlobManager3();
		bm.clear();
		assertEquals(0,bm.getNumBlobs());
	}

	@Test
	@DisplayName("containsBlob(id)-valid id")
	void testContainsBlob_true() {
		BlobManager bm = buildBlobManager3();
		String expectedId = "2345";
		boolean isPresent = bm.containsBlob(expectedId);
		assertEquals(true, isPresent);

	}

	@Test
	@DisplayName("containsBlob(id)-invalid id")
	void testContainsBlob_false() {
		BlobManager bm = buildBlobManager3();
		String invalidId = "9999";
		boolean isPresent = bm.containsBlob(invalidId);
		assertEquals(true, isPresent);
	}

	BlobManager buildBlobManager3() {
		BlobManager bm = new BlobManager();
		Blob[] blobs = { new Blob("1234"), new Blob("2345"),
				new Blob("3456") };
		for(Blob b : blobs) {
			bm.addBlob(b);
		}
		return bm;
	}
}
