package design_example_map;
/**
 * Utility class that contains a static method to validate a proposed Blob id.
 * @author dgibson
 *
 */
public class BlobValidator {
	/**
	 * Determines whether id is a valid Blob id. Currently, an id is valid if it has
	 * exactly 4 digits.
	 * @param id The proposed Blob id.
	 * @return The status of the id.
	 */
	public static BlobIdStatus isIdValid(String id) {
		if(id.length() != 4) {  // Length is required to be 4
			return new BlobIdStatus(id, false, "Code length must be 4");
		}
		
		for(int i=0; i<id.length(); i++) {  // Required to be composed of all digits
			if(!Character.isDigit(id.charAt(i))) {
				return new BlobIdStatus(id, false, "Code must only contain digits");
			}
		}
		// If id passes the tests, then return a BlobIDStatus that indicates this.
		return new BlobIdStatus(id, true);
	}

	public static void main(String[] args) {
	}
	
}
